<?php
namespace SM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\ConfContratoTipoRescisaoService;
use SM\Traits\TResponse;

class ConfContratoTipoRescisaoController
{

    use TResponse;

    protected $tipoRescisaoService;

    public function __construct(ConfContratoTipoRescisaoService $tipoRescisaoService)
    {
        $this->tipoRescisaoService = $tipoRescisaoService;
    }

    public function getTipoRescisao()
    {
        try {
            $data = $this->tipoRescisaoService->getTipoRescisao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getModeloDocumento()
    {
        try {
            $data = $this->tipoRescisaoService->getModeloDocumento();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function editarTipoRescisao(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->tipoRescisaoService->editarTipoRescisao($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirTipoRescisao(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->tipoRescisaoService->excluirTipoRescisao($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
