<?php

namespace SM\Service;

class SmDocumentosService
{

    protected $fileServerApiKeys;
    protected $tempDir;

    public function __construct($fileServerApiKeys)
    {
        $this->fileServerApiKeys = $fileServerApiKeys;
        $this->tempDir = sys_get_temp_dir();
        // $this->tempDir = '/home/developer/workfolder/anexos';
    }

    /**
     * Baixa um arquivo
     **/
    public static function downloadArquivo($fileDir, $fileName, $fileType, $fileSize, $istemporary = true)
    {
        header('Accept-Ranges: none');
        header('Content-Type: ' . $fileType);
        header('Content-Length: ' . $fileSize);
        header('Content-Disposition: inline; filename="' . $fileName . '"');

        ob_clean();
        flush();
        readfile($fileDir);

        if ($istemporary) {
            unlink($fileDir);
        }

        exit;
    }

    /**
     * Busca um documento no fileServer e retorna seu conteúdo.
     **/
    public function getDocumentoFileServer($urlArquivo, $nrorg)
    {
        $header = array(
            "apiKey: " . $this->fileServerApiKeys[$nrorg]
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $urlArquivo);
        curl_setopt($ch, CURLOPT_POST, false);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 90);

        $resultado = curl_exec($ch);
        $error     = curl_error($ch);
        curl_close($ch);

        if (!empty($error)) {
            throw new \Exception($error);
        }

        if (strpos($resultado, "404 Not Found") !== false) {
            //throw new \Exception($resultado);
            return false;
        } else {
            return $resultado;
        }
    }

    /**
     * Busca um documento no fileServer e salva-o numa pasta temporária. Retorna o caminho físico do arquivo salvo.
     **/
    public function downloadDocFileServer($urlArquivo, $nomeArquivoParaSalvar, $nrorg)
    {
        $conteudoArquivo = $this->getDocumentoFileServer($urlArquivo, $nrorg);
        if ($conteudoArquivo !== false) {
            if (is_dir($this->tempDir) && is_writable($this->tempDir)) {
                $caminhoFisicoArquivo = $this->tempDir . DIRECTORY_SEPARATOR . $nomeArquivoParaSalvar;
                file_put_contents($caminhoFisicoArquivo, $conteudoArquivo);
                return $caminhoFisicoArquivo;
            } else {
                throw new \Exception("Falha ao salvar o documento. <br/>O diretório \"" . $this->tempDir . "\" não existe ou não possui permissão para escrita.");
            }
        } else {
            throw new \Exception("Falha ao baixar o documento. <br/>O arquivo correspondente à URL \"" . $urlArquivo . "\" não existe.");
        }
    }
}
